JUCE: ScopedTryWriteLock Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ScopedTryWriteLock Class Reference
juce_core » threads

Automatically locks and unlocks a ReadWriteLock object. More...

`#include <juce_ScopedWriteLock.h>`

## Public Member Functions
| ScopedTryWriteLock (ReadWriteLock &lockIn) noexcept
| Creates a ScopedTryWriteLock and calls ReadWriteLock::tryEnterWrite() immediately.
| ScopedTryWriteLock (ReadWriteLock &lockIn, bool acquireLockOnInitialisation) noexcept
| Creates a ScopedTryWriteLock.
| ~ScopedTryWriteLock () noexcept
| Destructor.
bool | isLocked () const noexcept
| Returns true if the mutex was successfully locked.
bool | retryLock () noexcept
| Retry gaining the lock by calling tryEnter on the underlying lock.

## Detailed Description

Automatically locks and unlocks a ReadWriteLock object.

Use one of these as a local variable to control access to a ReadWriteLock.

e.g.

ReadWriteLock myLock;
for (;;)
{
const ScopedTryWriteLock myScopedTryLock (myLock);
// Unlike using a ScopedWriteLock, this may fail to actually get the lock, so you
// should test this with the isLocked() method before doing your thread-unsafe
// action.
if (myScopedTryLock.isLocked())
{
...do some stuff...
}
else
{
..our attempt at locking failed because some other thread has already locked the object..
}
// myLock gets unlocked here (if it was locked).
}
ReadWriteLock
A critical section that allows multiple simultaneous readers.
Definition juce_ReadWriteLock.h:49
ScopedTryWriteLock
Automatically locks and unlocks a ReadWriteLock object.
Definition juce_ScopedWriteLock.h:121

See also
  ReadWriteLock, ScopedTryWriteLock

## Constructor & Destructor Documentation

## ◆ ScopedTryWriteLock() [1/2]

ScopedTryWriteLock::ScopedTryWriteLock | ( | ReadWriteLock & | lockIn | ) |
| noexcept

Creates a ScopedTryWriteLock and calls ReadWriteLock::tryEnterWrite() immediately.

When the ScopedTryWriteLock object is destructed, the ReadWriteLock will be unlocked (if it was successfully acquired).

Make sure this object is created and destructed by the same thread, otherwise there are no guarantees what will happen! Best just to use it as a local stack object, rather than creating one with the new() operator.

## ◆ ScopedTryWriteLock() [2/2]

ScopedTryWriteLock::ScopedTryWriteLock | ( | ReadWriteLock & | lockIn,
|  | bool | acquireLockOnInitialisation )
| noexcept

Creates a ScopedTryWriteLock.

If acquireLockOnInitialisation is true then as soon as it is created, this will call ReadWriteLock::tryEnterWrite(), and when the ScopedTryWriteLock object is destructed, the ReadWriteLock will be unlocked (if it was successfully acquired).

Make sure this object is created and destructed by the same thread, otherwise there are no guarantees what will happen! Best just to use it as a local stack object, rather than creating one with the new() operator.

## ◆ ~ScopedTryWriteLock()

ScopedTryWriteLock::~ScopedTryWriteLock | ( |  | ) |
| noexcept

Destructor.

The ReadWriteLock's exitWrite() method will be called when the destructor is called.

Make sure this object is created and destructed by the same thread, otherwise there are no guarantees what will happen!

## Member Function Documentation

## ◆ isLocked()

bool ScopedTryWriteLock::isLocked | ( |  | ) | const
| noexcept

Returns true if the mutex was successfully locked.

## ◆ retryLock()

bool ScopedTryWriteLock::retryLock | ( |  | ) |
| noexcept

Retry gaining the lock by calling tryEnter on the underlying lock.

The documentation for this class was generated from the following file:

- juce_ScopedWriteLock.h